DROP PROC TestSudoku81Parms;
go
CREATE PROC TestSudoku81Parms
 @R1C1 char(1) = NULL,
 @R1C2 char(1) = NULL,
 @R1C3 char(1) = NULL,
 @R1C4 char(1) = NULL,
 @R1C5 char(1) = NULL,
 @R1C6 char(1) = NULL,
 @R1C7 char(1) = NULL,
 @R1C8 char(1) = NULL,
 @R1C9 char(1) = NULL,
 @R2C1 char(1) = NULL,
 @R2C2 char(1) = NULL,
 @R2C3 char(1) = NULL,
 @R2C4 char(1) = NULL,
 @R2C5 char(1) = NULL,
 @R2C6 char(1) = NULL,
 @R2C7 char(1) = NULL,
 @R2C8 char(1) = NULL,
 @R2C9 char(1) = NULL,
 @R3C1 char(1) = NULL,
 @R3C2 char(1) = NULL,
 @R3C3 char(1) = NULL,
 @R3C4 char(1) = NULL,
 @R3C5 char(1) = NULL,
 @R3C6 char(1) = NULL,
 @R3C7 char(1) = NULL,
 @R3C8 char(1) = NULL,
 @R3C9 char(1) = NULL,
 @R4C1 char(1) = NULL,
 @R4C2 char(1) = NULL,
 @R4C3 char(1) = NULL,
 @R4C4 char(1) = NULL,
 @R4C5 char(1) = NULL,
 @R4C6 char(1) = NULL,
 @R4C7 char(1) = NULL,
 @R4C8 char(1) = NULL,
 @R4C9 char(1) = NULL,
 @R5C1 char(1) = NULL,
 @R5C2 char(1) = NULL,
 @R5C3 char(1) = NULL,
 @R5C4 char(1) = NULL,
 @R5C5 char(1) = NULL,
 @R5C6 char(1) = NULL,
 @R5C7 char(1) = NULL,
 @R5C8 char(1) = NULL,
 @R5C9 char(1) = NULL,
 @R6C1 char(1) = NULL,
 @R6C2 char(1) = NULL,
 @R6C3 char(1) = NULL,
 @R6C4 char(1) = NULL,
 @R6C5 char(1) = NULL,
 @R6C6 char(1) = NULL,
 @R6C7 char(1) = NULL,
 @R6C8 char(1) = NULL,
 @R6C9 char(1) = NULL,
 @R7C1 char(1) = NULL,
 @R7C2 char(1) = NULL,
 @R7C3 char(1) = NULL,
 @R7C4 char(1) = NULL,
 @R7C5 char(1) = NULL,
 @R7C6 char(1) = NULL,
 @R7C7 char(1) = NULL,
 @R7C8 char(1) = NULL,
 @R7C9 char(1) = NULL,
 @R8C1 char(1) = NULL,
 @R8C2 char(1) = NULL,
 @R8C3 char(1) = NULL,
 @R8C4 char(1) = NULL,
 @R8C5 char(1) = NULL,
 @R8C6 char(1) = NULL,
 @R8C7 char(1) = NULL,
 @R8C8 char(1) = NULL,
 @R8C9 char(1) = NULL,
 @R9C1 char(1) = NULL,
 @R9C2 char(1) = NULL,
 @R9C3 char(1) = NULL,
 @R9C4 char(1) = NULL,
 @R9C5 char(1) = NULL,
 @R9C6 char(1) = NULL,
 @R9C7 char(1) = NULL,
 @R9C8 char(1) = NULL,
 @R9C9 char(1) = NULL
AS
SET NOCOUNT ON;

CREATE TABLE #Problem
            (Row tinyint NOT NULL CHECK(Row BETWEEN 0 AND 8),
             Col tinyint NOT NULL CHECK(Col BETWEEN 0 AND 8),
             Val char(1) DEFAULT NULL CHECK(Val BETWEEN '1' AND '9'),
             PRIMARY KEY (Row, Col)
            );

WITH         Nums0To8
AS (SELECT   Num
    FROM     Numbers
    WHERE    Num BETWEEN 0 AND 8)
INSERT INTO  #Problem (Row, Col)
SELECT       r.Num, c.Num  -- Implicit conversion will be used
FROM         Nums0To8 AS r
CROSS JOIN   Nums0To8 AS c;

IF @R1C1 IS NOT NULL UPDATE #Problem SET Val = @R1C1 WHERE Row = 0 AND Col = 0;
IF @R1C2 IS NOT NULL UPDATE #Problem SET Val = @R1C2 WHERE Row = 0 AND Col = 1;
IF @R1C3 IS NOT NULL UPDATE #Problem SET Val = @R1C3 WHERE Row = 0 AND Col = 2;
IF @R1C4 IS NOT NULL UPDATE #Problem SET Val = @R1C4 WHERE Row = 0 AND Col = 3;
IF @R1C5 IS NOT NULL UPDATE #Problem SET Val = @R1C5 WHERE Row = 0 AND Col = 4;
IF @R1C6 IS NOT NULL UPDATE #Problem SET Val = @R1C6 WHERE Row = 0 AND Col = 5;
IF @R1C7 IS NOT NULL UPDATE #Problem SET Val = @R1C7 WHERE Row = 0 AND Col = 6;
IF @R1C8 IS NOT NULL UPDATE #Problem SET Val = @R1C8 WHERE Row = 0 AND Col = 7;
IF @R1C9 IS NOT NULL UPDATE #Problem SET Val = @R1C9 WHERE Row = 0 AND Col = 8;

IF @R2C1 IS NOT NULL UPDATE #Problem SET Val = @R2C1 WHERE Row = 1 AND Col = 0;
IF @R2C2 IS NOT NULL UPDATE #Problem SET Val = @R2C2 WHERE Row = 1 AND Col = 1;
IF @R2C3 IS NOT NULL UPDATE #Problem SET Val = @R2C3 WHERE Row = 1 AND Col = 2;
IF @R2C4 IS NOT NULL UPDATE #Problem SET Val = @R2C4 WHERE Row = 1 AND Col = 3;
IF @R2C5 IS NOT NULL UPDATE #Problem SET Val = @R2C5 WHERE Row = 1 AND Col = 4;
IF @R2C6 IS NOT NULL UPDATE #Problem SET Val = @R2C6 WHERE Row = 1 AND Col = 5;
IF @R2C7 IS NOT NULL UPDATE #Problem SET Val = @R2C7 WHERE Row = 1 AND Col = 6;
IF @R2C8 IS NOT NULL UPDATE #Problem SET Val = @R2C8 WHERE Row = 1 AND Col = 7;
IF @R2C9 IS NOT NULL UPDATE #Problem SET Val = @R2C9 WHERE Row = 1 AND Col = 8;

IF @R3C1 IS NOT NULL UPDATE #Problem SET Val = @R3C1 WHERE Row = 2 AND Col = 0;
IF @R3C2 IS NOT NULL UPDATE #Problem SET Val = @R3C2 WHERE Row = 2 AND Col = 1;
IF @R3C3 IS NOT NULL UPDATE #Problem SET Val = @R3C3 WHERE Row = 2 AND Col = 2;
IF @R3C4 IS NOT NULL UPDATE #Problem SET Val = @R3C4 WHERE Row = 2 AND Col = 3;
IF @R3C5 IS NOT NULL UPDATE #Problem SET Val = @R3C5 WHERE Row = 2 AND Col = 4;
IF @R3C6 IS NOT NULL UPDATE #Problem SET Val = @R3C6 WHERE Row = 2 AND Col = 5;
IF @R3C7 IS NOT NULL UPDATE #Problem SET Val = @R3C7 WHERE Row = 2 AND Col = 6;
IF @R3C8 IS NOT NULL UPDATE #Problem SET Val = @R3C8 WHERE Row = 2 AND Col = 7;
IF @R3C9 IS NOT NULL UPDATE #Problem SET Val = @R3C9 WHERE Row = 2 AND Col = 8;

IF @R4C1 IS NOT NULL UPDATE #Problem SET Val = @R4C1 WHERE Row = 3 AND Col = 0;
IF @R4C2 IS NOT NULL UPDATE #Problem SET Val = @R4C2 WHERE Row = 3 AND Col = 1;
IF @R4C3 IS NOT NULL UPDATE #Problem SET Val = @R4C3 WHERE Row = 3 AND Col = 2;
IF @R4C4 IS NOT NULL UPDATE #Problem SET Val = @R4C4 WHERE Row = 3 AND Col = 3;
IF @R4C5 IS NOT NULL UPDATE #Problem SET Val = @R4C5 WHERE Row = 3 AND Col = 4;
IF @R4C6 IS NOT NULL UPDATE #Problem SET Val = @R4C6 WHERE Row = 3 AND Col = 5;
IF @R4C7 IS NOT NULL UPDATE #Problem SET Val = @R4C7 WHERE Row = 3 AND Col = 6;
IF @R4C8 IS NOT NULL UPDATE #Problem SET Val = @R4C8 WHERE Row = 3 AND Col = 7;
IF @R4C9 IS NOT NULL UPDATE #Problem SET Val = @R4C9 WHERE Row = 3 AND Col = 8;

IF @R5C1 IS NOT NULL UPDATE #Problem SET Val = @R5C1 WHERE Row = 4 AND Col = 0;
IF @R5C2 IS NOT NULL UPDATE #Problem SET Val = @R5C2 WHERE Row = 4 AND Col = 1;
IF @R5C3 IS NOT NULL UPDATE #Problem SET Val = @R5C3 WHERE Row = 4 AND Col = 2;
IF @R5C4 IS NOT NULL UPDATE #Problem SET Val = @R5C4 WHERE Row = 4 AND Col = 3;
IF @R5C5 IS NOT NULL UPDATE #Problem SET Val = @R5C5 WHERE Row = 4 AND Col = 4;
IF @R5C6 IS NOT NULL UPDATE #Problem SET Val = @R5C6 WHERE Row = 4 AND Col = 5;
IF @R5C7 IS NOT NULL UPDATE #Problem SET Val = @R5C7 WHERE Row = 4 AND Col = 6;
IF @R5C8 IS NOT NULL UPDATE #Problem SET Val = @R5C8 WHERE Row = 4 AND Col = 7;
IF @R5C9 IS NOT NULL UPDATE #Problem SET Val = @R5C9 WHERE Row = 4 AND Col = 8;

IF @R6C1 IS NOT NULL UPDATE #Problem SET Val = @R6C1 WHERE Row = 5 AND Col = 0;
IF @R6C2 IS NOT NULL UPDATE #Problem SET Val = @R6C2 WHERE Row = 5 AND Col = 1;
IF @R6C3 IS NOT NULL UPDATE #Problem SET Val = @R6C3 WHERE Row = 5 AND Col = 2;
IF @R6C4 IS NOT NULL UPDATE #Problem SET Val = @R6C4 WHERE Row = 5 AND Col = 3;
IF @R6C5 IS NOT NULL UPDATE #Problem SET Val = @R6C5 WHERE Row = 5 AND Col = 4;
IF @R6C6 IS NOT NULL UPDATE #Problem SET Val = @R6C6 WHERE Row = 5 AND Col = 5;
IF @R6C7 IS NOT NULL UPDATE #Problem SET Val = @R6C7 WHERE Row = 5 AND Col = 6;
IF @R6C8 IS NOT NULL UPDATE #Problem SET Val = @R6C8 WHERE Row = 5 AND Col = 7;
IF @R6C9 IS NOT NULL UPDATE #Problem SET Val = @R6C9 WHERE Row = 5 AND Col = 8;

IF @R7C1 IS NOT NULL UPDATE #Problem SET Val = @R7C1 WHERE Row = 6 AND Col = 0;
IF @R7C2 IS NOT NULL UPDATE #Problem SET Val = @R7C2 WHERE Row = 6 AND Col = 1;
IF @R7C3 IS NOT NULL UPDATE #Problem SET Val = @R7C3 WHERE Row = 6 AND Col = 2;
IF @R7C4 IS NOT NULL UPDATE #Problem SET Val = @R7C4 WHERE Row = 6 AND Col = 3;
IF @R7C5 IS NOT NULL UPDATE #Problem SET Val = @R7C5 WHERE Row = 6 AND Col = 4;
IF @R7C6 IS NOT NULL UPDATE #Problem SET Val = @R7C6 WHERE Row = 6 AND Col = 5;
IF @R7C7 IS NOT NULL UPDATE #Problem SET Val = @R7C7 WHERE Row = 6 AND Col = 6;
IF @R7C8 IS NOT NULL UPDATE #Problem SET Val = @R7C8 WHERE Row = 6 AND Col = 7;
IF @R7C9 IS NOT NULL UPDATE #Problem SET Val = @R7C9 WHERE Row = 6 AND Col = 8;

IF @R8C1 IS NOT NULL UPDATE #Problem SET Val = @R8C1 WHERE Row = 7 AND Col = 0;
IF @R8C2 IS NOT NULL UPDATE #Problem SET Val = @R8C2 WHERE Row = 7 AND Col = 1;
IF @R8C3 IS NOT NULL UPDATE #Problem SET Val = @R8C3 WHERE Row = 7 AND Col = 2;
IF @R8C4 IS NOT NULL UPDATE #Problem SET Val = @R8C4 WHERE Row = 7 AND Col = 3;
IF @R8C5 IS NOT NULL UPDATE #Problem SET Val = @R8C5 WHERE Row = 7 AND Col = 4;
IF @R8C6 IS NOT NULL UPDATE #Problem SET Val = @R8C6 WHERE Row = 7 AND Col = 5;
IF @R8C7 IS NOT NULL UPDATE #Problem SET Val = @R8C7 WHERE Row = 7 AND Col = 6;
IF @R8C8 IS NOT NULL UPDATE #Problem SET Val = @R8C8 WHERE Row = 7 AND Col = 7;
IF @R8C9 IS NOT NULL UPDATE #Problem SET Val = @R8C9 WHERE Row = 7 AND Col = 8;

IF @R9C1 IS NOT NULL UPDATE #Problem SET Val = @R9C1 WHERE Row = 8 AND Col = 0;
IF @R9C2 IS NOT NULL UPDATE #Problem SET Val = @R9C2 WHERE Row = 8 AND Col = 1;
IF @R9C3 IS NOT NULL UPDATE #Problem SET Val = @R9C3 WHERE Row = 8 AND Col = 2;
IF @R9C4 IS NOT NULL UPDATE #Problem SET Val = @R9C4 WHERE Row = 8 AND Col = 3;
IF @R9C5 IS NOT NULL UPDATE #Problem SET Val = @R9C5 WHERE Row = 8 AND Col = 4;
IF @R9C6 IS NOT NULL UPDATE #Problem SET Val = @R9C6 WHERE Row = 8 AND Col = 5;
IF @R9C7 IS NOT NULL UPDATE #Problem SET Val = @R9C7 WHERE Row = 8 AND Col = 6;
IF @R9C8 IS NOT NULL UPDATE #Problem SET Val = @R9C8 WHERE Row = 8 AND Col = 7;
IF @R9C9 IS NOT NULL UPDATE #Problem SET Val = @R9C9 WHERE Row = 8 AND Col = 8;

/* Uncomment the lines below to test functionality; leave commented for performance comparison. */
/*
-- Display the puzzle
SELECT ' ' + MAX(CASE WHEN Col = 0 THEN Val ELSE ' ' END) + ' ' +
             MAX(CASE WHEN Col = 1 THEN Val ELSE ' ' END) + ' ' +
             MAX(CASE WHEN Col = 2 THEN Val ELSE ' ' END) + ' ' +
            '| ' +
             MAX(CASE WHEN Col = 3 THEN Val ELSE ' ' END) + ' ' +
             MAX(CASE WHEN Col = 4 THEN Val ELSE ' ' END) + ' ' +
             MAX(CASE WHEN Col = 5 THEN Val ELSE ' ' END) + ' ' +
            '| ' +
             MAX(CASE WHEN Col = 6 THEN Val ELSE ' ' END) + ' ' +
             MAX(CASE WHEN Col = 7 THEN Val ELSE ' ' END) + ' ' +
             MAX(CASE WHEN Col = 8 THEN Val ELSE ' ' END) +
             CASE WHEN Row IN (2, 5) THEN CHAR(13) + '-------+-------+-------' ELSE '' END  AS "Starting problem"
FROM         #Problem
GROUP BY     Row
ORDER BY     Row;
*/
go
